package client.Java_client;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.historic.NodeHistoric;
import hero.historic.ProjectHistoric;
import hero.historic.PropertyHistoric;
import hero.interfaces.*;

import java.util.*;

public class ExecutionHistoryApis {
	
	static public void main(String[] args) throws Exception{
		
		char[] password={'b','s','o','a'};
		SimpleCallbackHandler handler = 
			new SimpleCallbackHandler("bsoa",password);
		LoginContext lc = new LoginContext("TestClient", handler);
		lc.login();
		
		ProjectSessionHome projectSessionh=ProjectSessionUtil.getHome();
		ProjectSession pss=projectSessionh.create();
		
		// Creates an instance of this process
		pss.instantiateProject("Approval_workflow");							
		
		UserSessionHome userSessionh=UserSessionUtil.getHome();
		UserSession uss=userSessionh.create();
				
		// Get Todo list for this user for all running instances
		Collection activites = uss.getToDoListAllInstances();	
		
		Iterator acts = activites.iterator();
		while (acts.hasNext())
		{
			BnNodeValue activity = (BnNodeValue)acts.next();
			pss.initProject(activity.getBnProject().getName());
			pss.setNodeProperty("Approval", "decision", "grant");
			uss.startActivity(activity.getBnProject().getName(), activity.getName());
			uss.terminateActivity(activity.getBnProject().getName(), activity.getName());
			
			activites = uss.getToDoListAllInstances();
			acts = activites.iterator();
		}
		
		// At this point the workflow instance is finished (all activities are done)
		// and so the instance related data is saved in a separate repository.
		// The HistoryAPI allows to retrieve data from finished instances.
		
		HistorySessionHome hsh =  HistorySessionUtil.getHome();
		HistorySession hs = hsh.create();
		
		Collection pl = hs.getHistoryProjectList();
		Iterator projects = pl.iterator();
		while (projects.hasNext())
		{
			// Getting process names having finished instances
			
			String projectName = (String)projects.next();
			System.out.println("Process Name = " + projectName);
			
			// Getting finished instances for this process			
			Collection instances = hs.getHistoryInstancesList(projectName);
			Iterator insts = instances.iterator();
			while (insts.hasNext())
			{
				String instName =(String)insts.next();
				
				int index = instName.indexOf(".xml");
				instName= instName.substring(0,index);
				
				System.out.println("Instance Name = "+instName);
				ProjectHistoric ph = (ProjectHistoric)hs.getHistoryInstance(instName);
				System.out.println("Name = "+ph.getName());
				System.out.println("Version = "+ph.getVersion());
				System.out.println("Creation Date = "+ph.getCreationDate());
				System.out.println("End Date = "+ph.getEndDate());
				System.out.println("Initiator = "+ph.getInitiator()+"\n");
				
				// Getting instance properties
				Collection properties = ph.getProperties();
				
				Iterator props = properties.iterator();
				while (props.hasNext())
				{					
					PropertyHistoric propH = (PropertyHistoric)props.next();
					System.out.println("Property Key = "+propH.getKey());
					System.out.println("Property Value = "+propH.getValue()+"\n");
				}
				
				// Getting instances activities
				Collection nodes = ph.getNodes();
				
				Iterator nds = nodes.iterator();
				while (nds.hasNext())
				{					
					NodeHistoric nodeH = (NodeHistoric)nds.next();
					System.out.println("Node name = "+nodeH.getName());
					System.out.println("Node Description = "+nodeH.getDescription());
					System.out.println("Node End date = "+nodeH.getEndDate());
					System.out.println("Node Start date = "+nodeH.getStartDate()+"\n");
				}
			}
			
		}						
		pss.remove();
	}
}

